lightoj1057_状压dp

题目链接:http://lightoj.com/volume_showproblem.php?problem=1057

题目大意:在二维矩阵中,给你一个起点和至多15个的目标点。要你求出从起点出发经过完所有的点后回到起点的最短路径值。每个点一步可以向 八个方向走。

没有金子的时候特判

 1 #include <algorithm>
 2 #include <iostream>
 3 #include <cstring>
 4 #include <cstdlib>
 5 #include <cstdio>
 6 #include <vector>
 7 #include <ctime>
 8 #include <queue>
 9 #include <list>
10 #include <cmath>
11 #include <set>
12 #include <map>
13 using namespace std;
14 #define INF 0x3f3f3f3f
15 typedef long long LL;
16
17 char s[25][25];
18 int x[20], y[20], dp[1<<15][20];
19 int Distance(int a, int b)
20 {
21     return max(fabs(y[b]-y[a]), fabs(x[b]-x[a]));
22 }
23 int main()
24 {
25     int t, n, m;
26     scanf("%d", &t);
27     for(int ca = 1; ca <= t; ca++)
28     {
29         scanf("%d %d", &n, &m);
30         for(int i = 0; i < n; i++)
31             scanf("%s", s[i]);
32         int k = 0;
33         for(int i = 0; i < n; i++)
34             for(int j = 0; j < m; j++)
35                 if(s[i][j]==‘x‘)
36                     x[0] = i, y[0] = j;
37                 else if(s[i][j] == ‘g‘)
38                 {
39                     k++;
40                     x[k] = i, y[k] = j;
41                 }
42         if(k == 0)
43         {
44             printf("Case %d: 0\n", ca);
45             continue;
46         }
47         memset(dp, INF, sizeof(dp));
48         for(int i = 0; i < k; i++)
49             dp[1<<i][i+1] = Distance(0, i+1);
50         for(int i = 2; i <= k; i++)
51         {
52             for(int j = 1; j < (1<<k); j++)
53             {
54                 int te = j, Zero[20], yi[20], l0=0, l1=0;
55                 for(int l = 0; l < k; l++)
56                 {
57                     if(te % 2)
58                         yi[++l1] = l;
59                     else
60                         Zero[++l0] = l;
61                     te >>= 1;
62                 }
63                 if(l1 != i - 1)
64                     continue;
65                 for(int d0 = 1; d0 <= l0; d0++)
66                 {
67                     int k0 = Zero[d0];
68                     for(int d1 = 1; d1 <= l1; d1++)
69                     {
70                         int k1 = yi[d1];
71                         if(dp[j][k1+1] != INF)
72                             dp[j|(1<<k0)][k0+1] = min(dp[j|(1<<k0)][k0+1], dp[j][k1+1]+Distance(k0+1, k1+1));
73                     }
74                 }
75             }
76         }
77         int res = INF;
78         for(int i = 1; i <= k; i++)
79         {
80             dp[(1<<k)-1][i] += dp[1<<(i-1)][i];
81             res = min(dp[(1<<k)-1][i], res);
82         }
83         printf("Case %d: %d\n", ca, res);
84     }
85     return 0;
86 }
时间: 2024-08-24 06:30:06

lightoj1057_状压dp的相关文章

ZOJ3305Get Sauce 状压DP,

状压DP的题目留个纪念,首先题意一开始读错了,搞了好久,然后弄好了,觉得DFS可以,最后超时,修改了很久还是超时,没办法看了一下n的范围,然后觉得状压可以,但是没有直接推出来,就记忆化搜索了一下,可是一直错,莫名奇妙,然后没办法看了一下题解,发现了下面这个比较好的方法,然后按照这个方程去推,然后敲,也是WA了好多把,写的太搓了,没人家的清楚明了,唉~也算是给自己留个纪念,状压一直做的都不太好~唉~还好理解了, 参考了  http://blog.csdn.net/nash142857/articl

poj 2411 Mondriaan&#39;s Dream(状压DP)

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 12232   Accepted: 7142 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

(状压dp)uva 10817 Headmaster&#39;s Headache

题目地址 1 #include <bits/stdc++.h> 2 typedef long long ll; 3 using namespace std; 4 const int MAX=1e5+5; 5 const int INF=1e9; 6 int s,m,n; 7 int cost[125]; 8 //char sta[MAX]; 9 string sta; 10 int able[125]; 11 int dp[125][1<<8][1<<8]; 12 in

HDU5816 Hearthstone(状压DP)

题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5816 Description Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation an

HDU 4336 容斥原理 || 状压DP

状压DP :F(S)=Sum*F(S)+p(x1)*F(S^(1<<x1))+p(x2)*F(S^(1<<x2))...+1; F(S)表示取状态为S的牌的期望次数,Sum表示什么都不取得概率,p(x1)表示的是取x1的概率,最后要加一因为有又多拿了一次.整理一下就可以了. 1 #include <cstdio> 2 const int Maxn=23; 3 double F[1<<Maxn],p[Maxn]; 4 int n; 5 int main() 6

Travel(HDU 4284状压dp)

题意:给n个城市m条路的网图,pp在城市1有一定的钱,想游览这n个城市(包括1),到达一个城市要一定的花费,可以在城市工作赚钱,但前提有工作证(得到有一定的花费),没工作证不能在该城市工作,但可以走,一个城市只能工作一次,问pp是否能游览n个城市回到城市1. 分析:这个题想到杀怪(Survival(ZOJ 2297状压dp) 那个题,也是钱如果小于0就挂了,最后求剩余的最大钱数,先求出最短路和 Hie with the Pie(POJ 3311状压dp) 送披萨那个题相似. #include <

BZOJ 1087: [SCOI2005]互不侵犯King( 状压dp )

简单的状压dp... dp( x , h , s ) 表示当前第 x 行 , 用了 h 个 king , 当前行的状态为 s . 考虑转移 : dp( x , h , s ) = ∑ dp( x - 1 , h - cnt_1( s ) , s' ) ( s and s' 两行不冲突 , cnt_1( s ) 表示 s 状态用了多少个 king ) 我有各种预处理所以 code 的方程和这有点不一样 ------------------------------------------------

BZOJ 1072 排列 状压DP

题意:链接 方法:状压DP? 题解:这题其实没啥好写的,不算很难,推一推就能搞出来. 首先看到这个问题,对于被d整除这个条件,很容易就想到是取余数为0,所以想到可能状态中刚开始含有取余数. 先说我的第一个想法,f[i][j]表示选取i个数且此时的mod为j,这样的思想是第一下蹦出来的,当时想的就是在线来搞最终的答案.不过转瞬即发现,这TM不就是暴力吗魂淡!并没有什么卵用,于是开始想这个状态可不可以做什么优化. 显然第二维的j并不需要太大的优化,暂且先将其搁置一边,来考虑第一维的i怎么优化. 把滚

COdeforces#417D Cunning Gena(状压DP)

A boy named Gena really wants to get to the "Russian Code Cup" finals, or at least get a t-shirt. But the offered problems are too complex, so he made an arrangement with his n friends that they will solve the problems for him. The participants